package com.fp.persistence.pgeneral.gene;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Query;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.fp.dto.hb.HibernateBean;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENESOLICITUDECREDITOPENING*/
@Entity(name="TgeneSolicitudeCreditOpening")
@Table(name="TGENESOLICITUDECREDITOPENING")
public class TgeneSolicitudeCreditOpening extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneSolicitudeCreditOpening
*/
@EmbeddedId
private TgeneSolicitudeCreditOpeningKey pk;
@Column(name="CURRENCYCODE", nullable=true)

/**
* Codigo de moneda en la que esta expresado el valor a aplicar dependiendo al forma de debito
*/
private String currencycode;

@Column(name="CASH", nullable=true)

/**
* Indica que el valor se entrega en efectivo.
*/
private String cash;

@Column(name="CHECKS", nullable=true)

/**
* Indica que el valor se entrega en cheques.
*/
private String checks;

@Column(name="CREDIT", nullable=true)

/**
* Indica que el valor se entrega con credito a uan cuenta o credito a un codigo contable.
*/
private String credit;

@Column(name="CREDITACCOUNT", nullable=true)

/**
* Numero de cuenta a la vista a realizar el credito, si la moneda de la cuenta es diferente a la moneda en la cual esta expresado el valor se tiene que hacer la compra venta de divisas
*/
private String creditaccount;

@Column(name="CREDITACCOUNTINGCODE", nullable=true)

/**
* Codigo contable a relaizar el credito.
*/
private String creditaccountingcode;

@Column(name="VALUE", nullable=true)

/**
* Valor en la moneda de la solicitud, la compra venta se hace en funcion a la moneda de la cuenta credito
*/
private BigDecimal value;

@Column(name="PERSONCODE", nullable=true)

/**
* Codigo de persona a emitir el cheque
*/
private Integer personcode;

@Column(name="IDBENEFICIARY", nullable=true)

/**
* Si no esta registrado como cliente, identificacion del beneficiario del cheque
*/
private String idbeneficiary;

@Column(name="BENEFICIARYNAME", nullable=true)

/**
* Nombre del beneficiario del cheque.
*/
private String beneficiaryname;

/**Contructor por defecto*/
public TgeneSolicitudeCreditOpening(){
}
/**Contructor de TgeneSolicitudeCreditOpening
@param pPk Clave Primaria del entity
*/
public TgeneSolicitudeCreditOpening(TgeneSolicitudeCreditOpeningKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneSolicitudeCreditOpening
*/
public static TgeneSolicitudeCreditOpening find(EntityManager pEntityManager,TgeneSolicitudeCreditOpeningKey pKey) throws Exception{
    TgeneSolicitudeCreditOpening obj = pEntityManager.find(TgeneSolicitudeCreditOpening.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneSolicitudeCreditOpening
@return El objeto que referencia a la Clave primaria de TgeneSolicitudeCreditOpening
*/
public TgeneSolicitudeCreditOpeningKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneSolicitudeCreditOpening
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneSolicitudeCreditOpening
*/
public void setPk(TgeneSolicitudeCreditOpeningKey pPk){
  pk=pPk;
}
/**Obtiene el valor de currencycode
@return valor de currencycode*/
public String getCurrencycode(){
  return currencycode;
}
/**Fija el valor de currencycode
@param pCurrencycode nuevo Valor de currencycode*/
public void setCurrencycode(String pCurrencycode){
  currencycode=pCurrencycode;
}

/**Obtiene el valor de cash
@return valor de cash*/
public String getCash(){
  return cash;
}
/**Fija el valor de cash
@param pCash nuevo Valor de cash*/
public void setCash(String pCash){
  cash=pCash;
}

/**Obtiene el valor de checks
@return valor de checks*/
public String getChecks(){
  return checks;
}
/**Fija el valor de checks
@param pChecks nuevo Valor de checks*/
public void setChecks(String pChecks){
  checks=pChecks;
}

/**Obtiene el valor de credit
@return valor de credit*/
public String getCredit(){
  return credit;
}
/**Fija el valor de credit
@param pCredit nuevo Valor de credit*/
public void setCredit(String pCredit){
  credit=pCredit;
}

/**Obtiene el valor de creditaccount
@return valor de creditaccount*/
public String getCreditaccount(){
  return creditaccount;
}
/**Fija el valor de creditaccount
@param pCreditaccount nuevo Valor de creditaccount*/
public void setCreditaccount(String pCreditaccount){
  creditaccount=pCreditaccount;
}

/**Obtiene el valor de creditaccountingcode
@return valor de creditaccountingcode*/
public String getCreditaccountingcode(){
  return creditaccountingcode;
}
/**Fija el valor de creditaccountingcode
@param pCreditaccountingcode nuevo Valor de creditaccountingcode*/
public void setCreditaccountingcode(String pCreditaccountingcode){
  creditaccountingcode=pCreditaccountingcode;
}

/**Obtiene el valor de value
@return valor de value*/
public BigDecimal getValue(){
  return value;
}
/**Fija el valor de value
@param pValue nuevo Valor de value*/
public void setValue(BigDecimal pValue){
  value=pValue;
}

/**Obtiene el valor de personcode
@return valor de personcode*/
public Integer getPersoncode(){
  return personcode;
}
/**Fija el valor de personcode
@param pPersoncode nuevo Valor de personcode*/
public void setPersoncode(Integer pPersoncode){
  personcode=pPersoncode;
}

/**Obtiene el valor de idbeneficiary
@return valor de idbeneficiary*/
public String getIdbeneficiary(){
  return idbeneficiary;
}
/**Fija el valor de idbeneficiary
@param pIdbeneficiary nuevo Valor de idbeneficiary*/
public void setIdbeneficiary(String pIdbeneficiary){
  idbeneficiary=pIdbeneficiary;
}

/**Obtiene el valor de beneficiaryname
@return valor de beneficiaryname*/
public String getBeneficiaryname(){
  return beneficiaryname;
}
/**Fija el valor de beneficiaryname
@param pBeneficiaryname nuevo Valor de beneficiaryname*/
public void setBeneficiaryname(String pBeneficiaryname){
  beneficiaryname=pBeneficiaryname;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneSolicitudeCreditOpening))return false;
    TgeneSolicitudeCreditOpening that = (TgeneSolicitudeCreditOpening) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneSolicitudeCreditOpening
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneSolicitudeCreditOpening
*/
public Object createInstance(){
 TgeneSolicitudeCreditOpening instance=new TgeneSolicitudeCreditOpening();	
 instance.setPk(new TgeneSolicitudeCreditOpeningKey());
 return instance;
}
/**Clona la entidad TgeneSolicitudeCreditOpening
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneSolicitudeCreditOpening p=(TgeneSolicitudeCreditOpening)this.clone();
  p.setPk((TgeneSolicitudeCreditOpeningKey)this.pk.cloneMe());
  return p;
}
	//Metodos manuales.
	/**Sentencia que devuelve uan lista con los valores a entregar al cliente asociados a una solicitud.*/
	private static final String HQL_SOLICITUDE_CREDIT =
	" from TgeneSolicitudeCreditOpening t  " +
	" where t.pk.solicitudnumber = :solicitudnumber "+
	" and t.pk.solicitudsequence = :solicitudsequence "+
	" order by t.pk.creditsequence ";

	/**
	 * Metodo que entrega una lista de valores a entregar al cliente, en la aperturad e una operacion. 
	 * @param pSolicitudNumber		Numero de solicitud. 
	 * @param pSolicitudSequence	Secuencia dentro de la solicitud. 
	 * @return	List<TgeneSolicitudeCreditOpening>
	 * @throws Exception
	 */
	@SuppressWarnings(com.fp.common.helper.Constant.VUNCHECKED)
	public static List<TgeneSolicitudeCreditOpening> find(EntityManager pEntityManager,
			String pSolicitudNumber,Integer pSolicitudSequence) throws Exception {
		List<TgeneSolicitudeCreditOpening>  lObjects = null;
		Query qry = pEntityManager.createQuery(HQL_SOLICITUDE_CREDIT);
		qry.setParameter("solicitudnumber", pSolicitudNumber);
		qry.setParameter("solicitudsequence", pSolicitudSequence);
		lObjects = qry.getResultList();
		return lObjects;
	}

}
